/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cviceni.actions;

import com.opensymphony.xwork2.ModelDriven;
import com.opensymphony.xwork2.Preparable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import cviceni.model.Student;
import org.apache.struts2.interceptor.SessionAware;
import cviceni.services.StudentService;

/**
 *
 * @author nav79
 */
public class StudentiAction extends Action implements ModelDriven<Student>, Preparable, SessionAware {

    private Student student;
    private int id;
    private Map<String, Object> session;

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    StudentService service = new StudentService();

    public StudentService getStudentService() {
        return service;
    }

    public void setService(StudentService service) {
        this.service = service;
    }

    public List<Student> getSeznamStudentu() {
        return service.getStudents();
    }

    @Override
    public Student getModel() {
        return student;
    }

    @Override
    public void prepare() throws Exception {
        initDb();

        if (id == 0) {
            student = new Student();
        } else {
            student = service.findStudentById(id);
        }
    }

    @Override
    public String execute() throws Exception {
        return SUCCESS;
    }


    public String update() {
        if (id == 0) {
            service.create(student);
            addActionMessage(getText("zaznamPridan"));
        } else {
            service.update(student);
            addActionMessage(getText("zaznamZmenen"));
        }        
        return SUCCESS;
    }

    /** delete the user and go to a default home page */
    public String delete() {
        service.deleteById(id);
        addActionMessage(getText("zaznamSmazan"));
        return LIST;
    }

    public String reset() {
        return INPUT;
    }
    
    @Override
    public void setSession(Map<String, Object> arg0) {
        session = arg0;
    }

    private Map<String, Object> getSession() {
        return session;
    }

    /**
     * Pomocná metoda pro simulaci připojení k databázi.
     */
    private void initDb() {
        Object db = session.get("DB");
        if (db == null) {
            Map<Integer, Student> studenti = new HashMap<Integer, Student>();
            Student s = new Student(1, "ben64", "Miroslav", "Beneš", 1);
            studenti.put(1, s);
            s = new Student(2, "von05", "Ivo", "Vondrák", 5);
            studenti.put(2, s);
            session.put("DB", studenti);
            service.setStudenti(studenti);
        } else {
            service.setStudenti((Map<Integer, Student>) db);
        }
    }

}
